PKG_ADD(1) | General Commands Manual | PKG_ADD(1)

# NAME

pkg_add — a utility for installing and upgrading software package distributions

# SYNOPSIS

pkg_add | [-AfILnRUuVv] [-C config] [-K pkg_dbdir] [-m machine] [-P destdir] [-p prefix] [-W viewbase] [-w view] file ... [[`ftp|http`]`://`[user][`:`password]`@`]host[`:`port][`/`path/]pkg-name ...

# DESCRIPTION

The pkg_add command is used to extract and upgrade packages that have been previously created with the pkg_create(1) command. Packages are prepared collections of pre-built binaries, documentation, configurations, installation instructions and/or other files. pkg_add can recursively install other packages that the current package depends on or requires from both local disk and via FTP or HTTP.

# WARNING

Since the pkg_add command may execute scripts or programs contained within a package file, your system may be susceptible to “Trojan horses” or other subtle attacks from miscreants who create dangerous package files.

You are advised to verify the competence and identity of those who provide installable package files. For extra protection, use the digital signatures provided where possible (see the pkg_install.conf(5)), or, failing that, use tar(1) to extract the package file, and inspect its contents and scripts to ensure it poses no danger to your system's integrity. Pay particular attention to any +INSTALL or +DEINSTALL files, and inspect the +CONTENTS file for @cwd, @mode (check for setuid), @dirrm, @exec, and @unexec directives, and/or use the pkg_info(1) command to examine the package file.

# OPTIONS

The following command line arguments are supported:

pkg-name [...]
  The named packages are installed. pkg_add will first try to use pkg-name as full URL or path name without any wildcard processing. If that fails, pkg_add will try to match packages using wildcard processing. If that fails as well and pkg-name does not contain any /, the entries of the PKG_PATH variable are searched using the wildcard processing rules.
-A
  Mark package as installed automatically, as dependency of another package. You can use

  > `pkg_admin set automatic=YES`

  to mark packages this way after installation, and

  > `pkg_admin unset automatic`

  to remove the mark. If you pkg_add a package without specifying -A after it had already been automatically installed, the mark is removed.
-C config
  Read the configuration file from config instead of the system default.
-f
  Force installation to proceed even if prerequisite packages are not installed or the install script fails. Although pkg_add will still try to find and auto-install missing prerequisite packages, a failure to find one will not be fatal. This flag also overrides the fatal error when the operating system or architecture the package was built on differ from that of the host.
-D
  Force updating even if the dependencies of depending packages are not satisfied by the new package. This is used by "make replace", after which one would typically replace the depending packages.
-I
  If an installation script exists for a given package, do not execute it.
-K pkg_dbdir
  Override the value of the PKG_DBDIR configuration option with the value pkg_dbdir.
-L
  Don't add the package to any views after installation.
-m
  Override the machine architecture returned by uname with machine.
-n
  Don't actually install a package, just report the steps that would be taken if it was.
-P destdir
  Prefix all file and directory names with destdir. For packages without install scripts this has the same behavior as using chroot(8).
-p prefix
  Override the prefix stored in the package with prefix.
-R
  Do not record the installation of a package. This implies -I. This means that you cannot deinstall it later, so only use this option if you know what you are doing!
-U
  Replace an already installed version from a package. Implies -u.
-u
  If the package that's being installed is already installed, an update is performed. Installed dependent packages are updated recursively, if they are too old to fulfill the dependencies of the to-be-installed version. See below for a more detailed description of the process.
-V
  Print version number and exit.
-v
  Turn on verbose output.
-W viewbase
  Passed down to pkg_view(1) for managed views.
-w view
  Passed down to pkg_view(1) for managed views.

One or more pkg-name arguments may be specified, each being either a file containing the package (these usually ending with the “.tgz” suffix) or a URL pointing at a file available on an ftp or web site. Thus you may extract files directly from their anonymous ftp or WWW locations (e.g., pkg_add ftp://ftp.NetBSD.org/pub/pkgsrc/packages/NetBSD/i386/3.1_2007Q2/shells/bash-3.2.9.tgz or pkg_add http://www.example.org/packages/screen-4.0.tbz). Note: For ftp transfers, if you wish to use

passive mode
ftp in such transfers, set the variable
FTP_PASSIVE_MODE
to some value in your environment. Otherwise, the more standard ACTIVE mode may be used. If pkg_add consistently fails to fetch a package from a site known to work, it may be because you have a firewall that demands the usage of
passive mode
ftp.

# TECHNICAL DETAILS

pkg_add extracts each package's meta data (including the “packing list”) to memory and then runs through the following sequence to fully extract the contents of the package:

1. A check is made to determine if the package or another version of it is already recorded as installed. If it is, installation is terminated if the -u or -U options are not given.

   If the same version is installed and -U is not given, it is marked as manually installed and process stops. If the -u option is given, it's assumed the package should be replaced by the new version instead. Before doing so, all packages that depend on the pkg being upgraded are checked if they also work with the new version. If that test is not successful, the dependent packages are updated first. The replacing is then prepared by moving an existing +REQUIRED_BY file aside (if it exists), and running pkg_delete(1) on the installed package. Installation then proceeds as if the package was not installed, and restores the +REQUIRED_BY file afterwards.

2. The package build information is extracted from the +BUILD_INFO file and compared against the result of uname(3). If the operating system or architecture of the package differ from that of the host, installation is aborted. This behavior is overridable with the -f flag.
3. The package build information from +BUILD_INFO is then checked for USE_ABI_DEPENDS=NO (or IGNORE_RECOMMENDED). If the package was built with ABI dependency recommendations ignored, a warning will be issued.
4. A check is made to determine if the package conflicts (from @pkgcfl directives, see pkg_create(1)) with an already recorded as installed package or if an installed package conflicts with the package. If it is, installation is terminated.
5. The file list of the package is compared to the file lists of the installed packages. If there is any overlap, the installation is terminated.
6. All package dependencies (from @pkgdep directives, see pkg_create(1)) are read from the packing list. If any of these required packages are not currently installed, an attempt is made to find and install it; if the missing package cannot be found or installed, the installation is terminated.
7. If the package contains an install script, it is executed with the following arguments:
   pkg-name
     The name of the package being installed.
   PRE-INSTALL
     Keyword denoting that the script is to perform any actions needed before the package is installed.

   If the install script exits with a non-zero status code, the installation is terminated.

8. The files from the file list are extracted to the chosen prefix.
9. If an install script exists for the package, it is executed with the following arguments:
   pkg_name
     The name of the package being installed.
   POST-INSTALL
     Keyword denoting that the script is to perform any actions needed after the package has been installed.
10. After installation is complete, a copy of the packing list, deinstall script, description, and display files are copied into <PKG_DBDIR>/<pkg-name> for subsequent possible use by pkg_delete(1). Any package dependencies are recorded in the other packages' +REQUIRED_BY file.
11. If the package is a depoted package, then add it to the registered by calling pkg_view(1) accordingly.
12. Finally, if we were upgrading a package, any +REQUIRED_BY file that was moved aside before upgrading was started is now moved back into place.

The install script is called with the environment variable PKG_PREFIX set to the installation prefix (see the -p option above). This allows a package author to write a script that reliably performs some action on the directory where the package is installed, even if the user might change it with the -p flag to pkg_add. The scripts are also called with the PKG_METADATA_DIR environment variable set to the location of the +* meta-data files, and with the PKG_REFCOUNT_DBDIR environment variable set to the location of the package reference counts database directory. If the -P flag was given to pkg_add, PKG_DESTDIR will be set to destdir. Additionally, PKG_METADATA_DIR and PKG_REFCOUNT_DBDIR are prefixed with destdir.

# ENVIRONMENT

See pkg_install.conf(5) for options, that can also be specified using the environment. Packages using views are also affected by the environment variables documented for pkg_view(1).

# EXAMPLES

In all cases, pkg_add will try to install binary packages listed in dependencies list.

You can specify a compiled binary package explicitly on the command line.

    # pkg_add /usr/pkgsrc/packages/All/tcsh-6.14.00.tgz

If you omit the version number, pkg_add will install the latest version available. With -v, pkg_add emits more messages to terminal.

    # pkg_add -v /usr/pkgsrc/packages/All/unzip

You can grab a compiled binary package from remote location by specifying a URL. The base URL can also be provided by the configuration variable, PKG_PATH.

    # pkg_add -v ftp://ftp.NetBSD.org/pub/pkgsrc/packages/NetBSD/i386/3.1_2007Q2/All/firefox-2.0.0.4.tgz

    # export PKG_PATH=ftp://ftp.NetBSD.org/pub/pkgsrc/packages/NetBSD/i386/3.1_2007Q2/All
    # pkg_add -v firefox

# SEE ALSO

pkg_admin(1), pkg_create(1), pkg_delete(1), pkg_info(1), pkg_install.conf(5), pkgsrc(7)

# AUTHORS

Jordan Hubbard
  Initial work and ongoing development.
John Kohl
  NetBSD refinements.
Hubert Feyrer
  NetBSD wildcard dependency processing, pkgdb, upgrading, etc.
Thomas Klausner
  HTTP support.
Joerg Sonnenberger
  Rewrote most of the code base to work without external commands.

# BUGS

Package upgrading needs a lot more work to be really universal.

Sure to be others.

June 16, 2010 | NetBSD 6.0